﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.Problems.TradeRules
{
    class OnlineTradeRulesCalculator
    {
        public static double Calculate(IEnumerable<double> estimatedValues, IRegressionProblemData problemData, IEnumerable<int> rows)
        {/*
            const double commission = 0.25;
            const double EAR = 4.00;  //Effective Anual Rate 

            double DayRat = 0; //One day interest
            double interest = 0.0; // Interest for one day
            double[] arrayDate = problemData.Dataset.GetDoubleValues("\"Date\"").ToArray(); //Array with all dates in UNIX format

            //int count = rows.ToList()[0];
 
            bool intoMarket = false;//Equivalent to be into the market
            int totalTradeDays = 0;
            int numberTrades = 0;
            int tradeDays = 0;
            double dayBefore = 0.0;
            double yesterday = 0.0;
            double buyPrice = 0.0;
            double sellPrice = 0.0;
            string stringPrice = "";
            int nShares = 0;
            double cash = 10000.00;
            double expend = 0.0;
            double equity = 0.0;
            double profit1 = 0.0;
            double charged = 0.0;

            IEnumerator<int> initialRow = rows.GetEnumerator();
            initialRow.MoveNext();
            int numDays1 = (int)arrayDate[initialRow.Current-1];
            int numDays2 = (int) arrayDate[(initialRow.Current)];
            int count = initialRow.Current + 1;
            
            IEnumerator<double> enumerator = estimatedValues.GetEnumerator();
            enumerator.MoveNext();
            dayBefore = enumerator.Current;
            enumerator.MoveNext();
            yesterday = enumerator.Current;

            DayRat = 360 * (Math.Pow((1 + (EAR / 100)), (1 / 360)) - 1);

            while (enumerator.MoveNext())
            {
                if (!intoMarket)
                {
                    if (dayBefore == -1 && yesterday == 1)
                    {
                        intoMarket = true;
                        stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
                        buyPrice = Convert.ToDouble(stringPrice);
                        totalTradeDays++; numberTrades++; tradeDays++; //Increasing trading variables
                        nShares = (int)Math.Floor(cash / (buyPrice * (1.0 + commission / 100)));
                        expend = buyPrice * nShares * (1 + commission / 100);
                        cash = cash - expend + interest;
                        equity = cash + nShares * buyPrice * (1 - commission / 100);
                        interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
                    }
                    else  //Dia normal fuera del mercado
                    {
                        cash = cash + interest;
                        equity = equity + cash;
                        interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
                    }

                }
                else if (dayBefore == 1 && yesterday == -1)
                {
                    intoMarket = false;
                    stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
                    sellPrice = Convert.ToDouble(stringPrice);
                    profit1 += sellPrice - buyPrice;
                    charged = sellPrice * nShares * (1 - commission / 100);
                    cash = cash + charged + interest;
                    equity = cash;
                    interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
                    nShares = 0;
                }
                else
                {
                    cash = cash + interest;
                    tradeDays += numDays1;
                    totalTradeDays += numDays1;
                    equity = cash + nShares * Convert.ToDouble(problemData.Dataset.GetValue(count, 0)) * (1 - commission / 100);
                    interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
                }

                dayBefore = yesterday;
                yesterday = enumerator.Current;
                numDays1 = numDays2;
                numDays2 = (int) arrayDate[count];
                count++;
            }
            if (intoMarket)
            {
                intoMarket = false;
                stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
                sellPrice = Convert.ToDouble(stringPrice);
                profit1 += sellPrice - buyPrice;
                charged = sellPrice * nShares * (1 - commission / 100);
                cash = cash + charged + interest;
                equity = cash;
                nShares = 0;
            }
            return numDays1;*/

            const double commission = 0.25;
            const double EAR = 4.00;  //Effective Anual Rate 

            double DayRat = 0; //One day interest
            double interest = 0.0; // Interest for one day
            double[] arrayDate = problemData.Dataset.GetDoubleValues("\"Date\"").ToArray(); //Array with all dates in UNIX format
            int nDias1 = 0;
            int nDias2 = 0;


            bool intoMarket = false;//Equivalent to be into the market
            int totalTradeDays = 0;
            int numberTrades = 0;
            int tradeDays = 0;
            double buyPrice = 0.0;
            double sellPrice = 0.0;
            string stringPrice = "";
            int nShares = 0;
            double cash = 10000.00;
            double expend = 0.0;
            double equity = 0.0;
            double profit1 = 0.0;
            double charged = 0.0;

            //SECOND EVALUATOR
            var enumerator = estimatedValues.GetEnumerator();
            int count = rows.ToList()[2];
            int count2 = 2;
            int date1 = (int)arrayDate[rows.ToList()[0]];
            int date2 = (int)arrayDate[rows.ToList()[1]];

            enumerator.MoveNext();
            double dayBefore = enumerator.Current;
            enumerator.MoveNext();
            double yesterday = enumerator.Current;
            
            DayRat = 268 * (Math.Pow((1 + (EAR / 100)),(1 / 268)) - 1);
            nDias2 = date2 - date1;
            
            while (enumerator.MoveNext())
            {
                if (!intoMarket)
                {
                    if (dayBefore == -1 && yesterday == 1)
                    {
                        intoMarket = true;
                        stringPrice = problemData.Dataset.GetValue(count, 1); //Extracting Open values
                        buyPrice = Convert.ToDouble(stringPrice);
                        totalTradeDays++; numberTrades++; tradeDays++; //Increasing trading variables
                        nShares = (int)Math.Floor(cash / (buyPrice * (1.0 + commission / 100)));
                        expend = buyPrice * nShares * (1 + commission / 100);
                        cash = cash - expend + interest;
                        equity = cash + nShares * buyPrice * (1 - commission / 100);
                        interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
                    }
                    else  //Dia normal fuera del mercado
                    {
                        tradeDays++;
                        totalTradeDays++;
                        cash = cash + interest;
                        equity = equity+cash;
                        interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
                    }
                }
                else if (dayBefore == 1 && yesterday == -1)
                {
                    intoMarket = false;
                    stringPrice = problemData.Dataset.GetValue(count, 1); //Extracting Open values
                    sellPrice = Convert.ToDouble(stringPrice);
                    profit1 += sellPrice - buyPrice;
                    charged = sellPrice * nShares * (1 - commission / 100);
                    cash = cash + charged+interest;
                    equity = cash;
                    interest = cash + Math.Pow((1 + DayRat / 268), nDias2) - cash;
                    nShares = 0;
                }
                else
                {
                    cash = cash + interest;
                    tradeDays++;
                    totalTradeDays++;
                    equity = cash + nShares * Convert.ToDouble(problemData.Dataset.GetValue(count,1)) * (1 - commission / 100);
                    interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
                }

                dayBefore = yesterday;
                yesterday = enumerator.Current;
                date1 = date2;
                date2 = (int)arrayDate[rows.ToList()[count2]];
                
                int nDiasAux = nDias1;
                nDias1 = nDias2;
                nDias2 = date2-date1;

                count++;
                count2++;
            }

            if (intoMarket)
            {
                intoMarket = false;
                stringPrice = problemData.Dataset.GetValue((count-1), 1); //Extracting Open values
                sellPrice = Convert.ToDouble(stringPrice);
                profit1 += sellPrice - buyPrice;
                charged = sellPrice * nShares * (1 - commission / 100);
                cash = cash + charged + interest;
                equity = cash;
                nShares = 0;
            }
            return cash;
        }
    }
}
